import matplotlib.pyplot as plt
import json
from sklearn.manifold import TSNE
import pickle
import numpy as np
import torch
## 读取low_dim_emb
# result_file_low_dim_emb = open("./result/act/dd_our_sent_low_dim.pkl", "rb")
# low_dim_emb_1 = pickle.load(result_file_low_dim_emb)
# result_file_low_dim_emb.close()

# low_dim_emb=[]
# with open('./dd/lab.json', encoding='utf-8') as f:
#     raw_data = json.load(f)

# labels=[]
# labels_1=raw_data 

# for i,u in enumerate(labels_1):
#     if(u != -1 and u!=0):
#         labels.append(u)
#         #low_dim_emb.append(low_dim_emb_1[i])
# low_dim_emb=np.array(low_dim_emb_1)

# 降维
def visual(feat):
    # t-SNE的最终结果的降维与可视化
    ts = TSNE(n_components=2, init='pca', random_state=0)

    x_ts = ts.fit_transform(feat)

    print(x_ts.shape)  # [num, 2]

    x_min, x_max = x_ts.min(0), x_ts.max(0)

    x_final = (x_ts - x_min) / (x_max - x_min)

    return x_final

# # 可视化
def plot_with_labels(low_dim_emb, labels):
    #iemocap
    # colors_dic = { "0": "limegreen", "1": "steelblue", "2": "brown", "3": "orange","4": "darkorchid", "5": "yellow"}
    # markers_dic = {"0": ".", "1": ",", "2": "*", "3": "^",
    #               "4": "d", "5": "2"}
    # ss_dic = {"0": 6, "1": 5, "2": 5, "3": 5,
    #               "4": 5, "5": 5}
    # labels_dic={'0':'hap','1': 'sad','2':'neu','3':'ang','4':'exc','5':'fru'}
    
    #meld
    colors_dic = { "0": "limegreen", "1": "steelblue", "2": "brown", "3": "orange","4": "darkorchid", "5": "yellow", "6":"red"}
    markers_dic = {"0": ".", "1": ",", "2": "*", "3": "^",
                  "4": "d", "5": "2", "6":'D'}
    ss_dic = {"0": 4, "1": 4, "2": 4, "3": 4,
                  "4": 4, "5": 4, "6": 4}
    labels_dic={'0':'neu','1': 'sur','2':'fea','3':'sad','4':'joy','5':'dis', '6':'ang'}
    

    plt.cla()

    # 降到二维了，分别给x和y
    X, Y = low_dim_emb[:, 0], low_dim_emb[:, 1]
    lb=[]
    lb_dic=[]
    for i in range(len(labels)):
        if labels[i] not in lb:
            plt.scatter(X[i], Y[i], color=colors_dic[str(labels[i])],marker=markers_dic[str(labels[i])],s=ss_dic[str(labels[i])])
            lb.append(labels[i])
            lb_dic.append(labels_dic[str(labels[i])])
    plt.rcParams.update({'font.size':7})
    plt.legend(lb_dic)

    for x, y, s in zip(X, Y, labels):

        plt.scatter(x, y, color=colors_dic[str(s)],marker=markers_dic[str(s)],s=ss_dic[str(s)])


    # 不显示x、y轴
    plt.axis('off')

    plt.savefig("meld.jpg", dpi=500)


## 画图
# with open ('features_later.pkl', 'rb') as f:
#     feat=pickle.load(f)
#     #feat=feat.detach().cpu().numpy()
# with open('labels.pkl', 'rb') as f1:
#     label_test=pickle.load(f1)
#     #label_test=label_test.detach().cpu().numpy()

label_test=np.load('test_label.npy')
feat=np.load('features_meld.npy')
plot_with_labels(visual(feat), label_test)